import { __assign } from "tslib";
import { options } from 'assemblyscript/cli/asc';
var ascSchemaOptions = Object.entries(options).reduce(function (ret, _a) {
    var _b;
    var key = _a[0], item = _a[1];
    // 只检验单个的值，数组不校验
    if (item.type && /[a-z]/.test(item.type)) {
        var schemaType = (function () {
            switch (item.type) {
                case 'b': return 'boolean';
                case 's': return 'string';
                case 'f':
                case 'i': return 'number';
                default: return 'null';
            }
        })();
        Object.assign(ret, (_b = {},
            _b[key] = {
                type: schemaType,
                default: item.default,
                description: item.description,
            },
            _b));
    }
    return ret;
}, {});
export var schemaOptions = {
    type: 'object',
    properties: __assign(__assign({}, ascSchemaOptions), { limit: {
            type: ['number', 'string'],
            description: 'Byte limit the size to the wasm file: size <= limit, wasm bundled into js ,or builded into output.wasm',
        }, name: {
            type: 'string',
        }, publicPath: {
            type: 'string',
        }, useInWorker: {
            type: 'boolean',
        } }),
    additionalProperties: true,
};
export var transOptionToAscOption = function (opt) {
    return Object.entries(options).reduce(function (ret, _a) {
        var key = _a[0], item = _a[1];
        var value = opt[key];
        if (value && item.type) {
            switch (item.type) {
                case 'b': {
                    ret.push("--" + key);
                    break;
                }
                default: {
                    ret.push("--" + key, "" + value);
                }
            }
        }
        return ret;
    }, []);
};
//# sourceMappingURL=option.js.map